<?php
if (! class_exists ( 'DTBooking_Cs_Sc_ServiceItem' ) ) {

    class DTBooking_Cs_Sc_ServiceItem {

        function DTBooking_sc_ServiceItem() {

			$plural_name = '';
			if( function_exists( 'ultimate_booking_pro_cs_get_option' ) ) :
				$plural_name	=	ultimate_booking_pro_cs_get_option( 'singular-service-text', esc_html__('Service', 'ultimate-booking-pro') );
			endif;

			$options = array(
			  'name'      => 'dt_sc_service_item',
			  'title'     => $plural_name,
			  'fields'    => array(

				array(
				  'id'    => 'service_id',
				  'type'  => 'text',
				  'title' => esc_html__( 'Enter Service ID', 'ultimate-booking-pro' ),
				  'after' => '<div class="cs-text-muted">'.esc_html__('Enter IDs of services to display. More than one ids with comma(,) seperated.', 'ultimate-booking-pro').'</div>',
				),
				array(
				  'id'        => 'type',
				  'type'      => 'select',
				  'title'     => esc_html__('Type', 'ultimate-booking-pro'),
				  'options'   => array(
					'type1'    => esc_html__('Type - 1', 'ultimate-booking-pro'),
					'type2'    => esc_html__('Type - 2', 'ultimate-booking-pro')
				  ),
				  'class'     => 'chosen',
				  'default'   => 'desc',
				  'info'      => esc_html__('Choose type of services to display.', 'ultimate-booking-pro')
				),
				array(
				  'id'        => 'excerpt',
				  'type'      => 'select',
				  'title'     => esc_html__('Show Excerpt?', 'ultimate-booking-pro'),
				  'options'   => array(
					'yes'   => esc_html__('Yes', 'ultimate-booking-pro'),
					'no'    => esc_html__('No', 'ultimate-booking-pro')
				  ),
				  'class'     => 'chosen',
				  'default'   => 'no',
				  'info'      => esc_html__('Choose "Yes" to show excerpt.', 'ultimate-booking-pro')
				),
				array(
				  'id'    => 'excerpt_length',
				  'type'  => 'text',
				  'title' => esc_html__( 'Excerpt Length', 'ultimate-booking-pro' ),
				  'default' => 12
				),
				array(
				  'id'        => 'meta',
				  'type'      => 'select',
				  'title'     => esc_html__('Show Meta?', 'ultimate-booking-pro'),
				  'options'   => array(
					'yes'   => esc_html__('Yes', 'ultimate-booking-pro'),
					'no'    => esc_html__('No', 'ultimate-booking-pro')
				  ),
				  'class'     => 'chosen',
				  'default'   => 'no',
				  'info'      => esc_html__('Choose "Yes" to show meta.', 'ultimate-booking-pro')
				),
				array(
				  'id'    => 'button_text',
				  'type'  => 'text',
				  'title' => esc_html__( 'Button Text', 'ultimate-booking-pro' ),
				  'default' => esc_html__('View procedure details', 'ultimate-booking-pro'),
				  'info'  => esc_html__( 'Enter button text.', 'ultimate-booking-pro' )
				)
			  ),
			);

			return $options;
		}
	}				
}