<?php
if (! class_exists ( 'DTBooking_Cs_Sc_StaffItem' ) ) {

    class DTBooking_Cs_Sc_StaffItem {

        function DTBooking_sc_StaffItem() {

			$plural_name = '';
			if( function_exists( 'ultimate_booking_pro_cs_get_option' ) ) :
				$plural_name	=	ultimate_booking_pro_cs_get_option( 'singular-staff-text', esc_html__('Staff', 'ultimate-booking-pro') );
			endif;

			$options = array(
			  'name'      => 'dt_sc_staff_item',
			  'title'     => $plural_name,
			  'fields'    => array(

				array(
				  'id'    => 'staff_id',
				  'type'  => 'text',
				  'title' => esc_html__( 'Enter Staff ID', 'ultimate-booking-pro' ),
				  'after' => '<div class="cs-text-muted">'.esc_html__('Enter ID of staff to display. More than one ids with comma(,) seperated.', 'ultimate-booking-pro').'</div>',
				),
				array(
				  'id'        => 'type',
				  'type'      => 'select',
				  'title'     => esc_html__('Type', 'ultimate-booking-pro'),
				  'options'   => array(
					'type1'    => esc_html__('Type - 1', 'ultimate-booking-pro'),
					'type2'    => esc_html__('Type - 2', 'ultimate-booking-pro')
				  ),
				  'class'     => 'chosen',
				  'default'   => 'desc',
				  'info'      => esc_html__('Choose type of staffs to display.', 'ultimate-booking-pro')
				),
				array(
				  'id'        => 'show_button',
				  'type'      => 'select',
				  'title'     => esc_html__('Show button?', 'ultimate-booking-pro'),
				  'options'   => array(
					'yes'   => esc_html__('Yes', 'ultimate-booking-pro'),
					'no'    => esc_html__('No', 'ultimate-booking-pro')
				  ),
				  'class'     => 'chosen',
				  'default'   => 'no',
				  'info'      => esc_html__('Choose "Yes" to show button.', 'ultimate-booking-pro')
				),
				array(
				  'id'    => 'button_text',
				  'type'  => 'text',
				  'title' => esc_html__( 'Button Text', 'ultimate-booking-pro' ),
				  'default' => esc_html__('Book an appointment', 'ultimate-booking-pro'),
				  'info'  => esc_html__( 'Enter button text.', 'ultimate-booking-pro' )
				)
			  ),
			);

			return $options;
		}
	}				
}